#!/usr/bin/python
#
# A sample python-session on creating a Product (You need to be located in the
# make_product/ directory):

# $Id: example1.py,v 1.5 2001/07/30 06:49:47 erik Exp $
# $Source: /cvs/make_product/examples/example1.py,v $
__version__='$Revision: 1.5 $'[11:-2]

"""Test properties"""

import builder

# the license
gpl = open('licenses/GPL').read() % {'author': 'Erik Enge',
                                     'authored_year': '2001',
                                     'author_email': 'erik@thingamy.net'}

# make a product instance
my_product = builder.zope_product_builder(id='TestProduct', license=gpl)

# add a klass to the instance
my_product.add_klass(builder.klass_builder(
    id='test_klass', meta_type='test_klass', license=my_product.license))

klas = my_product.get_klass('test_klass')
# add a subclass
klas.add_subklass(builder.klass_builder(
    id='other_klass', meta_type='other_klass', license=my_product.license))

# add properties
klas.add_property(builder.property_builder(id='title'))
klas.add_property(builder.property_builder(
    id='count', type='int', default=0))
klas.add_property(builder.property_builder(
    id='states', type='tokens', default=[]))

# this will write the product to disk
my_product.write_self()



