# $Id: make_product.py,v 1.3 2001/07/23 07:56:19 erik Exp $
# $Source: /cvs/make_product/make_product.py,v $
__version__='$Revision: 1.3 $'[11:-2]

"""This class provides methods for creating classes, their associated
files, attributes, methods and various other nitbits.  Everything
created is (or should be) compliant with the Zope Python Product API.

(I'm not actually sure if there is such a thing, but reading
source-code has got me this far.)"""

import OFS.Folder
import base_item
import builder

from Globals import DTMLFile, InitializeClass
from AccessControl import ClassSecurityInfo

make_product_add_form = DTMLFile('dtml/make_product_add_form', globals())
make_product_add = DTMLFile('dtml/make_product_add', globals())

def manage_add_make_product(self, id, REQUEST=None, **kw):
    """Add an instance of the make_product class"""
    self._setObject(id, make_product(id, kw))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class make_product(
    base_item.base_item,
    OFS.Folder.Folder):
    """Provide methods for setting up a Python Product that is
    compatible with the Zope Python Product API."""

    meta_type = 'make_product'
    icon = None

    manage_options = OFS.Folder.Folder.manage_options + (
        {'label':'Edit', 'action':'manage_editForm'},
        )
    
    _properties = (
        {'id':'title', 'type':'string', 'default':''},
        )

    security = ClassSecurityInfo()

    security.declarePublic('instanciate_product')
    def instanciate_zope_product(self, **kw):
        """Return an instance of the zope_product class"""
        id = kw['id']
        try: license = kw['license']
        except KeyError: license = ''
        try: docstring = kw['docstring']
        except KeyError: docstring = '"""doc string"""'
        try: default_indent = kw['default_indent']
        except KeyError: default_indent = '    '
        try: directory = kw['directory']
        except KeyError: directory = ''
        try: author = kw['author']
        except KeyError: author = ''
        try: author_email = kw['author_email']
        except KeyError: author_email = ''
        try: authored_year = kw['authored_year']
        except KeyError: authored_year = ''
        return builder.zope_product_builder(
            id=id, license=license, docstring=docstring,
            default_indent=default_indent, directory=directory,
            author=author, author_email=author_email,
            authored_year=authored_year)


InitializeClass(make_product)
