"""This module provides the base_item class"""

import OFS.PropertyManager
import Acquisition

from Globals import DTMLFile, InitializeClass, Persistent
from AccessControl import ClassSecurityInfo, Role
from Products.Formulator import StandardFields, Form

class base_item(
    Persistent,
    Acquisition.Implicit,
    Role.RoleManager,
    OFS.PropertyManager.PropertyManager):
    """It is intended that you subclass this class in all your classes
    (that you are going to use with Zope); so this class should
    provide all the common methods and superclasses."""

    meta_type = ''
    icon = ''
    meta_classes = ()
    _properties = ()

    # Would this actually be duplicated, and thus maybe overwritten?
    security = ClassSecurityInfo()

    security.declarePublic('standard_html_header')
    standard_html_header = DTMLFile('dtml/standard_html_header', globals())
    security.declarePublic('standard_html_footer')
    standard_html_footer = DTMLFile('dtml/standard_html_footer', globals())

    security.declarePrivate('__init__')
    def __init__(self, id, values={}):
        """Initialize the class instance"""
        self.id = id

        # Formulator magic
        self.edit_form = Form.BasicForm('manage_edit')

        for property in self._properties:
            if property['id'] in values.keys():
                self._setPropValue(property['id'], values[property['id']])
            elif property.has_key('default'):
                self._setPropValue(property['id'], property['default'])

    def manage_editForm(self):
        """doc string"""
        return self.edit_form.render()

    def manage_edit(self, REQUEST):
        """doc string"""
        self.manage_changeProperties(REQUEST)
        return REQUEST.RESPONSE.redirect(self.absolute_url() + '/manage_main')

    def index_html(self):
        "doc string"
        return self.edit_form.render()

InitializeClass(base_item)
